#include "stdafx.h"
#include "ListBj.h"
#include <iostream>

using namespace std;

bool byMin(const int &nMin, const int &nMax)
{
	if (nMin < nMax)
	{
		return true;
	}
	return false;
}

void SortMalloc(ClistBj<int> &m_list)
{
	POSITION *pSort = m_list.SortMalloc(byMin);

	int nLoop = 0;
	while (NULL != pSort[nLoop])
	{
		int &data = m_list.GetAt(pSort[nLoop]);
		printf("0x%x ", data);

		++nLoop;
	}

	delete[]pSort;
}

int main(int argc, char *argv[], char **envp)
{
	ClistBj<int> m_list;
	m_list.AddHead(0x32);
	m_list.AddHead(0x48);
	m_list.AddHead(0x55);
	m_list.AddHead(0x22);
	m_list.AddHead(0x99);

	// 表内排序
	m_list.Sort(byMin);

	POSITION pos = m_list.GetHeadPosition();
	while (NULL != pos)
	{
		int nNum = m_list.GetAt(pos);
		printf("0x%x ", nNum);
		m_list.GetNext(pos);
	}

	// 表外排序
	SortMalloc(m_list);
	return 0;
}

